#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "graph.h"

#define PIC 5
#define DISPMAX 70

//vg^Cv錾
unsigned char *load_ppm(const char *filename, int *width, int *height);
unsigned char *load_pgm(const char *filename, int *width, int *height);
int save_ppm(const char *filename, int width, int height, unsigned char *data);
int save_pgm(const char *filename, int width, int height, unsigned char *data);


//log2
int loglog2(int num){
  int ret=0;
  
  while(1){
    num=num/2;
    ret++;
    if(num==1) break;
  }
  return ret;
}

//œKȃI
int get_alpha(int data, int alphas[], int col){
  int i,j;
  int min,pmin=1000;
  int ret;

  for(i=0;i<col;i++){
    if(alphas[i]==-1) break;
    min=abs(alphas[i]-data);
    if(min<pmin){
      ret=alphas[i];
      pmin=min;
    }
    i++;
  }

  return ret;
}

/*SAD̎*/
int sad(int x, int y, unsigned char *img_l, unsigned char *img_r, int width, int height, int alpha){
  int i,j;
  int sum,minsum;
  int count;
  int pic=PIC;

  count=0;
  sum=0;
  for(i=-pic/2;i<=pic/2;i++){
    for(j=-pic/2;j<=pic/2;j++){
      if((x+i>=0) && (x+i<width) && (x-alpha+i>=0) && (y+j>=0) && (y+j<height)){
	count++;
	sum+=abs(img_l[x+i+(y+j)*width]-img_r[x+i-alpha+(y+j)*width]);
      }
    }
  }
  
  if(count!=0){
    sum=sum/count;
    double ce=ceil(sum*1.0*(DISPMAX/1.0/255));
    sum=(int)ce;
  }
  
  return sum;
}


/*o͉摜̍œK*/
void henkan(unsigned char *img, int width, int height, unsigned char *ans, int max){
  int x,y,sa;
  //int max=50;

  if(max==0){
    max=255;
    printf("max erro");
  }
  sa=255/max;
 
  for(y=0;y<height;y++){
    for(x=0;x<width;x++){
      if(img[x+y*width]*sa<=255){
	ans[x+y*width]=img[x+y*width]*sa;
      }else{
	ans[x+y*width]=255;
      }
    }
  }
}


/*************************************************************
 * WAtB^[                                        *
 *************************************************************/

/*r֐*/
int compare(const int *a, const int *b)
{
  return *a - *b;
}

int median(unsigned char *img, int width, int height, unsigned char *mask)
{
  int x,y,max=0;
  int *median;

  median=(int *)malloc(8 * sizeof(int));
 
  for(y=1;y<height-1;y++){
    for(x=1;x<width-1;x++){
      median[0]=img[(x-1)+(y-1)*width];
      median[1]=img[(x)+(y-1)*width];
      median[2]=img[(x+1)+(y-1)*width];
      median[3]=img[(x-1)+(y)*width];
      median[4]=img[(x+1)+(y)*width];
      median[5]=img[(x-1)+(y+1)*width];
      median[6]=img[(x)+(y+1)*width];
      median[7]=img[(x+1)+(y+1)*width];
      qsort(median,7,sizeof(int),(int (*)(const void*, const void*))compare);
      mask[x+y*width]=median[3];
      if(max<median[3]) max=median[3];
    }
  }
  for(x=0;x<width;x++){
    mask[x+0*width]=img[x+0*width];
    mask[x+(height-1)*width]=img[x+(height-1)*width];
  }
  for(y=0;y<height;y++){
    mask[0+y*width]=img[0+y*width];
    mask[(width-1)+y*width]=img[(width-1)+y*width];
  }
  mask[0+0*width]=img[0+0*width];
  free(median);
  return max;
}



/********************************************************************
 * main֐
 ********************************************************************/
int main(int argc, char *argv[])
{
  clock_t start,end;
  int nodeNum,allnodeNum;
  int edgeNum,alledgeNum;
  int i,j,k,x,y,alpha,alpha2;
  int width, height;
  unsigned char *data, *image_l, *image_r, *result;
  typedef Graph<int,int,int> GraphType;


  if(argc==3){
    printf("Ώۉ摜t@C1: %s\n", argv[1]);
    printf("Ώۉ摜t@C2: %s\n", argv[2]);
  }else if(argc<3){
    fprintf(stderr,"̐Ȃ܂!\n");
    fprintf(stderr,"R}h: ./graphcut 摜 E摜");
    return 1;
  }else{
    fprintf(stderr,"̐܂!\n");
    fprintf(stderr,"R}h: ./graphcut 摜 E摜");
    return 1;
  }

  start=clock(); //ԌvJn

  image_l = load_pgm(argv[1], &width, &height);
  image_r = load_pgm(argv[2], &width, &height);
  
  printf("TCY: width=%d,height=%d\n",width,height);

  nodeNum=width*height;
  edgeNum=(width-1)*height+width*(height-1);
  allnodeNum=nodeNum+edgeNum;
  alledgeNum=(width+(width-1)-1)*height+width*(height+(height-1)-1);

  data = (unsigned char *)malloc(width*height);
  result = (unsigned char *)malloc(width*height);
  
  //o͉摜̏l(͑SĂOƂj
  /*
  for(y=0;y<height;y++){
    for(x=0;x<width;x++){
      data[x+y*width]=ans[x+y*width];
    }
  }
  */

  //̔z쐬
  int num=64;
  int row=loglog2(num)*2;
  int col=num/4;

  int alphas[row][col];
  
  for(i=0;i<row;i++){
    for(j=0;j<row;j++){
      alphas[i][j]=-1;
    }
  }
  alphas[0][0]=0;
  alphas[1][0]=num/2;
  
  for(j=1;j<(row/2);j++){
    for(k=0;k<=(pow(2,j-1)-1);k++){
      alphas[j*2][k]=int((1+4*k)/(pow(2,j+1))*num);
      alphas[j*2+1][k]=int((3+4*k)/(pow(2,j+1))*num);
    }
  }


  //烋[vɓ
  printf("\nPlease Wait...\n\n");
  int large=2147483647;
  int LARGE=2147483647;
  int large2=10000;
  int success;
 
  for(j=0;j<LARGE;j++){
    success=0;
 
    for(k=0;k<row;k++){
      GraphType *g = new GraphType(/*estimated # of nodes*/ allnodeNum, /*estimated # of edges*/ alledgeNum);
  
      //sNZm[h̒ǉ
      x=0;
      y=0;
      for(i=0;i<nodeNum;i++){
	alpha=get_alpha(data[x+y*width],alphas[k],col);
	int sadd=sad(x,y,image_l,image_r,width,height,alpha);
	int sadd2=sad(x,y,image_l,image_r,width,height,data[x+y*width]);

	g->add_node();

	//g->add_tweights(i,abs(data[x+y*width]-sadd2),abs(alpha-sadd));
	g->add_tweights(i,sadd2,sadd);

	x++;
	if(x>=width){
	  y++;
	  x=0;
	}
      }
  

      //אړ_ǉ(c)
      x=0;
      y=0;
      int addnum=0;
      for(i=0;i<width*(height-1);i++){
	alpha=get_alpha(data[x+y*width],alphas[k],col);
	alpha2=get_alpha(data[x+(y+1)*width],alphas[k],col);
	
	if(alpha==alpha2 && data[x+y*width]==data[x+(y+1)*width]){
	  int v=abs(alpha-data[x+y*width]);
	  g->add_edge(i,i+width,v,v);
	}else{
	  int vb=abs(data[x+y*width]-data[x+(y+1)*width]);
	  int va=abs(alpha-alpha2);
	  g->add_node();
	  addnum++;
	  
	  g->add_tweights(i+nodeNum,vb,va);
	  
	  if(vb<=va){
	    int vab=abs(alpha-data[x+(y+1)*width])-vb;
	    if(vab<0) vab=0;
	    
	    int vba=abs(data[x+y*width]-alpha2)-vb;
	    if(vba<0) vba=0;
	    
	    g->add_edge(i,i+nodeNum,vab,large2);
	    g->add_edge(i+width,i+nodeNum,vba,large2);
	  }else{
	    int vab=abs(alpha-data[x+(y+1)*width])-va;
	    if(vab<0) vab=0;
	    
	    int vba=abs(data[x+y*width]-alpha2)-va;
	    if(vba<0) vba=0;
	    
	    g->add_edge(i,i+nodeNum,large2,vba);
	    g->add_edge(i+width,i+nodeNum,large2,vab);
	  }
	  
	  y++;
	  if(y>=height-1){
	    y=0;
	    x++;
	  }
	}
      }


      //̗אړ_m[hǉ
      int alll=nodeNum+addnum;
      for(i=0;i<(width-1)*height;i++){
	alpha=get_alpha(data[x+y*width],alphas[k],col);
	alpha2=get_alpha(data[x+1+y*width],alphas[k],col);
	
	if(alpha==alpha2 && data[x+y*width]==data[x+1+y*width]){
	  int v=abs(alpha-data[x+y*width]);
	  g->add_edge(i,i+1,v,v);
	}else{
	  int vb=abs(data[x+y*width]-data[x+1+y*width]);
	  int va=abs(alpha-alpha2);
	  g->add_node();

	  g->add_tweights(i+alll,vb,va);
	  
	  if(vb<=va){
	    int vab=abs(alpha-data[x+1+y*width])-vb;
	    if(vab<0) vab=0;
	    
	    int vba=abs(data[x+y*width]-alpha2)-vb;
	    if(vba<0) vba=0;
	    
	    g->add_edge(i,i+alll,vab,large2);
	    g->add_edge(i+1,i+alll,vba,large2);
	  }else{
	    int vab=abs(alpha-data[x+1+y*width])-va;
	    if(vab<0) vab=0;
	    
	    int vba=abs(data[x+y*width]-alpha2)-va;
	    if(vba<0) vba=0;
	    
	    g->add_edge(i,i+alll,large2,vba);
	    g->add_edge(i+1,i+alll,large2,vab);
	  }
	  
	  x++;
	  if(x>=width-1){
	    y++;
	    x=0;
	  }
	}
      }
      
      //ő嗬EŏJbgASY̓Kp
      int flow=g->maxflow();
      if(flow<large){
	large=flow;
	success=1;
	x=0;
	y=0;
	for(i=0;i<nodeNum;i++){
	  //SOURCEɑĂΒlXV
	  if(g->what_segment(i)==GraphType::SOURCE){
	    int alphaX=get_alpha(data[x+y*width],alphas[k],col);

	    data[x+y*width]=alphaX;
	  }

	  x++;
	  if(x>=width){
	    y++;
	    x=0;
	  }
	}
      }
   
      delete g;
    }
    if(success==0) break;
  }
  
  //fBAtB^ɂ
  int max=median(data,width,height,result);

  //o͉摜̍œK
  henkan(result,width,height,data,max);

  //o
  save_pgm("result.pgm",width,height,data);

  free(image_l);
  free(image_r);
  free(data);
  free(result);

  end=clock();
  printf("COMPLETE!\n");
  printf("time: %.2f [s]\n",(double)(end-start)/CLOCKS_PER_SEC);
  return 0;
}
